Ftest <- function(fitSmall,fitLarge)
  {
    ## Returns the p-value of an F test between the small model which is nested into the large model
    nSmall <- length(fitSmall$coefficients)
    nLarge <- length(fitLarge$coefficients)
    if(nSmall>=nLarge)
      {
        print(paste("nSmall",nSmall,"nLarge",nLarge))
        stop("The small model must have fewer parameters than the large model")
      }
    n <- length(fitSmall$residuals)
    rssSmall <- sum(fitSmall$residuals^2)
    rssLarge <- sum(fitLarge$residuals^2)
    if(rssSmall<rssLarge)
      {
        print(paste("rssSmall",rssSmall,"rssLarge",rssLarge))
        stop("The RSS must be lowest for the large model")
      }
    Fstat <- ((rssSmall-rssLarge)/(nLarge-nSmall))/(rssLarge/(n-nLarge))
    R <- list()
    R$nSmall <- nSmall
    R$nLarge <- nLarge
    R$rssSmall <- rssSmall
    R$rssLarge <- rssLarge
    R$pval <- 1-pf(Fstat,nLarge-nSmall,n-nLarge)
    return(R)
  }
