dapply <- function(X, FUN, bindfun = "cbind", return_dataframe = FALSE){
  val <- lapply(X, FUN)
  if (return_dataframe) {
    return(as.data.frame(do.call(bindfun, val)))
  } else {
    return(do.call(bindfun, val))
  }
}




## dapply(1:4, function(i) {
##   return(i)
## })

## sapply(1:4, function(i) {
##   return(c(i,i))
## })

## ## List if binding dataframes
## ## VERY SLOW
## tmp <- sapply(1:4, function(i) {
##   return(data.frame(i=c(i,i)))
## })
## str(tmp)


## sapply(1:4, function(i) {
##   return(matrix(c(i,i)))
## })

## ## It always does cbind
## dapply(1:4, function(i) {
##   return(t(matrix(c(i,i))))
## }, "rbind")


## require(microbenchmark)
## microbenchmark(
## sapply(1:4000, function(i) {
##   return(c(i,i))
## })
## ,
## dapply(1:4000, function(i) {
##   return(c(i,i))
## }),
##   times=10
##   )



## dapply(1:400, function(i) {
##   return(c(i,i))
## }, "cbind")
