## Create all cache names needed, first for optimization and then forecasts
genCacheName <- function(cachedir, forDigest, subdir=NA){
  ## Generate a folder name based on cachedir and elements in subdir
  if(!is.na(subdir)){
    tmp <- sapply(1:length(subdir), function(i){ eval(parse(text=gsub("/","",subdir[i])))})
    cachedir <- paste0(cachedir,"/",paste0(subdir,"_",tmp,collapse="-"))
  }
  dir.create(cachedir, showWarnings=FALSE, recursive=TRUE)
  ## Create the filename with digest
  fileName <- digest(forDigest)
  ## Return the cache name with path
  return(paste0(cachedir,"/",fileName,".rda"))
}
