interpolateWithLM <- function(inputGrid, output, newdata){
  ##
  inputGrid <- as.matrix(inputGrid)
  ## Find all the points inclosed by inputGrid
  icol <- rep(TRUE,ncol(newdata))
  for(i in 1:ncol(newdata)){
    nm <- names(newdata)[i]
    dist <- inputGrid[ ,nm] - newdata[,i]
    ii <- which(dist<=0)
    ikeep <- which(dist==dist[ii[which.min(abs(dist[ii]))]])
    if(length(ii)==0){ icol[i] <- FALSE }
    ##
    ii <- which(dist>0)
    ikeep <- c(ikeep,which(dist==dist[ii[which.min(abs(dist[ii]))]]))
    if(length(ii)==0){ icol[i] <- FALSE }
    ##
    inputGrid <- inputGrid[ikeep, ]
    output <- output[ikeep]
  }

  if(length(output)==1){ return(output) }

  if(sum(icol)==1){
    return(approx(inputGrid[ ,icol], output, xout=newdata[icol])$y)
  }
    
  inputGrid <- rbind(inputGrid,inputGrid)[ ,icol]
  output <- c(output-1,output+1)

  frml <- paste0("output ~ ", paste0(colnames(inputGrid), collapse="+"))
  inputGrid <- as.data.frame(inputGrid)
  inputGrid$output <- output

  fit <- lm(frml, data=inputGrid)
  predict(fit, newdata=newdata)
}



## inputGrid <- expand.grid(x1=seq(1,10,len=3), x2=seq(1,10,len=3), x3=seq(1,10,len=3))
## output <- 1:nrow(inputGrid)
## newdata <- data.frame(x1=5,x2=-10,x3=9)
## ##
## interpolate(inputGrid, output, newdata)
