## Make the weights with an Epanechnikov kernel
## h is relative to the unit
kernelEp <- function(xall,x,h)
{
  ## Special case for h==0
  if(h==0){ return((x==xall)*(3/4)) }
  ## Epanechnikov kernel
  u <- abs(xall-x)
  u <- u / h
  w <- 3/4 * (1 - u^2)
  ## Set values with |u|>1 to 0
  w[abs(u)>1] <- 0
  return(w)
}

