## Make the weights with an Epanechnikov kernel
## h is relative to the unit
kernelKNearest <- function(xall,x,k)
{
  ## Find the bandwidth from the k nearest neighbours
  dist <- abs(xall-x)
  i <- order(dist)
  ## Interpolate if k is not integer
  if(k%%1==0){
    ## If k is integer
    h <- dist[i[k]]
  }else{
    h1 <- dist[i[floor(k)]]
    h2 <- dist[i[ceiling(k)]]
    h <- h1 + (h2-h1)*(k-floor(k))
  }
  ## Calculate Epanechnikov weights
  kernelEp(xall, x, h)
}

