lagDF <- function(x,lags)
{
  if(is.null(dim(x)))
  {
    ## x is a vector
    as.data.frame(sapply(lags, function(k){lagVec(x,k)}))
  }else if(length(lags)>1){
    if(length(lags)==ncol(x)){
      ## lags has length equal to the number of columns in x
      nms <- names(x)
      x <- as.data.frame(sapply(1:length(lags), function(i){lagVec(x[ ,i],lags[i])}))
      names(x) <- nms
      return(x)
    }
  }else
  {
    ## x is a data.frame, but lags is a factor, so lag all
    if(lags > 0)
    {
      x[(lags+1):nrow(x), ] <-  x[1:(nrow(x)-lags), ]
      x[1:lags,] <- NA
      return(x)
    }
    else if(lags < 0)
    {
      lags <- -lags 
      x[1:(nrow(x)-lags), ] <-  x[(lags+1):nrow(x), ]
      x[(nrow(x)-lags+1):nrow(x), ] <- NA
      return(x)
    }
    else if(lags==0){ return(x) }
  }
}
