lagDT <- function(DT, nms, lags, perReference=FALSE)
{
  if(!perReference){
    ## Don't do it per reference
    X <- DT[ ,..nms]
    for(i in 1:length(lags)){
      if(lags[i] > 0){
        X[, c(names(X)[i]) := shift(.SD, lags[i], NA, "lag"), .SDcols=c(names(X)[i])]
      }else if(lags[i] < 0){
        X[, c(names(X)[i]) := shift(.SD, -lags[i], NA, "lead"), .SDcols=c(names(X)[i])]
      }
    }
    return(X)
  }else{
    ## Here also names of the columns to be shifted should be given
    ## Do it per reference
    for(i in 1:length(lags)){
      if(lags[i] > 0){
        DT[, c(nms[i]) := shift(.SD, lags[i], NA, "lag"), .SDcols=c(nms[i])]
      }else if(lags[i] < 0){
        DT[, c(nms[i]) := shift(.SD, -lags[i], NA, "lead"), .SDcols=c(nms[i])]
      }
    }
    invisible(NULL)
  }
}


