nnBandwidth <- function(xall,x,nn)
  {
    ## Remove NAs
    xall <- xall[is.finite(xall)]
    dx <- abs(x-xall)
    if(nn>length(xall)|!is.finite(x)) return(max(dx,0.01,na.rm=TRUE))
    ## return the bandwidth by interpolation
    orderedxall <- xall[order(dx)]
    floorval <- orderedxall[floor(nn)]
    hfloor <- abs(x - floorval)
    ceilingval <- orderedxall[ceiling(nn)]
    hceiling <- abs(x - ceilingval)
    ## Interpolate
    h <- hfloor + (hceiling - hfloor) * (nn-floor(nn))
    return(max(h,0.01))
  }
